#pragma once

#include"enet.h"

#include<cglm/vec3.h>

extern int LuaapiCamFocus;
extern vec3 LuaapiCamFocusPos;
extern vec3 LuaapiCamFocusDir;

extern mat4 LuaapiCamMatrix;

extern int LuaapiFirstPerson;

extern double LuaapiStartTime;
extern float LuaapiFov;

extern struct k3Tex *LuaapiSkybox;
extern vec4 LuaapiSkyboxRotation;
extern bool LuaapiSkyboxRotationFunky;

void luaapi_init();
void luaapi_load(const char *name);
void luaapi_render(double dt, double alpha);

void luaapi_render2d();

void luaapi_update();

// peer will be NULL if local player
int luaapi_join(ENetPeer *peer, int oldlua);
void luaapi_leave(int);

struct k3Mat;
void luaapi_fillmaterial_direct(struct k3Mat *mat);
void luaapi_fillmaterial(const char *src, struct k3Mat*);

struct k3Light *luaapi_getlights(size_t *count);

void luaapi_cleanup();

void luaapi_perform(const char *statement);

void luaapi_ctrlev(int ctrl, int action);

struct bstr;
int luaapi_recvmsg(struct bstr *b, int lua);

void luaapi_escape();

void luaapi_peercode_found(const char *peercode);
